
math.randomseed(os.time())

gamestate = 2

deadmusicPlaying = false

function love.load()
  
  require("button")
  require("progressbar")
  require("player")
  require("effects")
  require("blood")
  require("enemy")
  require("hit")
  require("swooshC")
  
  title = love.graphics.newImage("wicked.png")
  model = love.graphics.newImage("player.png")
  vig = love.graphics.newImage("vig.png")
  ground = love.graphics.newImage("ground.png")
  dead = love.graphics.newImage("dead.png")
  model2 = love.graphics.newImage("sword.png")
  model3 = love.graphics.newImage("enemy.png")
  armor1 = love.graphics.newImage("chainarmor.png")
  swooshi = love.graphics.newImage("swoosh.png")
  
  void = love.audio.newSource("void.wav")
  deadmusic = love.audio.newSource("slaughtered.wav")
  stab = love.audio.newSource("stab.wav")
  swooshs = love.audio.newSource("swoosh.wav")
  deadmusic:setLooping(true)
  
  playerdie = love.audio.newSource("playerdie.wav")
  enemydie = love.audio.newSource("enemydie.wav")
  
  
  require("tile")
  require("maploader")

  
  gamera = require("camera")
  
  cam = gamera.new(0,0,800,600)
  cam:setScale(0.2)
  
  tileAsset = love.graphics.newImage("tile.png")
  wallAsset = love.graphics.newImage("wall.png")
  wallAsset2 = love.graphics.newImage("wall2.png")
  chestAsset = love.graphics.newImage("chest.png")
  
  level1 = maps.loadMap("map.png")
  
  --enemy[#enemy+1] = enemy.spawn(400,300,1)

end




function love.update(dt)
  
  mouseWorldX, mouseWorldY = cam:toWorld(love.mouse.getX(),love.mouse.getY())
  
   cam:setWorld(0,0,500,500)
   cam.x = player.x
   cam.y = player.y
  if(#enemy < 10) then
    enemy[#enemy+1] = enemy.spawn(400,300,1)
  end
  

  player.update(dt)
  for _,v in ipairs(blood) do v:update(dt) end
  for _,v in ipairs(enemy) do v:update(dt) end
  for _,v in ipairs(hit) do v:update(dt) end
  for _,v in ipairs(swoosh) do v:update(dt) end
  for i = #blood, 1, -1 do if blood[i].delete then table.remove(blood, i) end end
  for i = #hit, 1, -1 do if hit[i].delete then table.remove(hit, i) end end
  for i = #enemy, 1, -1 do if enemy[i].die then table.remove(enemy, i) end end
  for i = #swoosh, 1, -1 do if swoosh[i].delete then table.remove(swoosh, i) end end
end

function love.draw()
  
  

  if(gamestate == 1) then
    love.graphics.draw(title,0,50)
  else
    
        
    if(player.shake) then
      shake()
    end
    
   -- if(player.stats[1] <= 0 ) then
   --   --love.graphics.setColor(10,10,15)
   -- end
  
    cam:draw(function(l,t,w,h)
        
      for _,v in ipairs(tile) do 
        if(math.sqrt((cam.x - v.x)^2+(cam.y-v.y)^2) < 650) then
          v:draw()
        end
      end
      for _,v in ipairs(blood) do v:draw() end
      for _,v in ipairs(enemy) do v:draw() end
      for _,v in ipairs(swoosh) do v:draw() end
  -- for _,v in ipairs(hit) do v:draw() end
      player.draw()
    end)
    
    player.healthbar:draw()
    player.staminabar:draw()
    
    if(player.stats[1] <= 0) then
      love.graphics.setColor(150,0,0,50)
      love.graphics.rectangle("fill",0,0,800,600)
      love.graphics.setColor(255,255,255,255)
      love.graphics.draw(dead)
      if(not deadmusicPlaying) then
        deadmusic:play()
        deadmusicPlaying = true
      end
    end
    
  end

  love.graphics.draw(vig)
  
  
end

function love.mousepressed(x,y,button)
  player.mousepressed(x,y,button)
end

function love.mousereleased(x,y,button)
  player.mousereleased(x,y,button)
end

function love.keypressed(key)
  player.keypressed(key)
end