

--[[
COLOR CODES:
64 = WALL
255 = TILE
38 = ENTRANCE
127 = WALL2
193 = CHEST
--]]


maps = {}

maps.__index = maps

function maps.loadMap(file)
  
  local self = {}
  
  self.map = {}
  
  self.entrance = 0
  self.exit = 0
  
  self.data = love.image.newImageData(file)
  self.pixels = {}
  
  local count = 0
  for y = 0, self.data:getHeight()-1 do
    for x = 0, self.data:getWidth()-1 do
      local pixel = self.data:getPixel(x,y)
      self.pixels[count] = pixel
      count = count + 1
    end
  end
  
  for i = 0, #self.pixels do
    local x = (i%50)
    local y = math.floor(i/50)
    
    tile[#tile + 1] = tile.new((x)*100,(y)*100,self.pixels[i],i)
  end
  
  
  return setmetatable(self,maps)
  
end

