phantom = {}

phantom.__index = phantom

function phantom.spawn(x,y,t)
  local self = {}
  
  self.x = x
  self.y = y
  self.angle = math.random(-6.28,6.28)
  self.timer = 0
  self.offsetx = 0
  self.offsety = 0
  self.rot = 0
  self.r = 255
  self.attacking = false
  
  
  self.target = 0
  -- hp maxHp attack defense stamina, maxStamina
  self.stats = {100,100,100,50,75,75}
  self.healthbar = progressbar.new(self.x,self.y,self,100,5,{155,0,0},1,2)
  
  local rot = self.angle + math.atan2(20,35)
 
  self.weapon = {}
  self.weapon.x = self.x + math.sqrt((35)^2+(20)^2) * math.cos(rot)
  self.weapon.y = self.y + math.sqrt((35)^2+(20)^2) * math.sin(rot)
  self.weapon.model = model2
  
  
  self.hitbox = {}
  self.hitbox.x = self.x
  self.hitbox.y = self.y
  self.hitbox.w = 50
  self.hitbox.h = 50

  
  self.die = false
  
  return setmetatable(self,phantom)
end

function phantom.update(self,dt)
  
  self.hitbox.x = self.x - self.hitbox.w/2
  self.hitbox.y = self.y - self.hitbox.h/2
  
  self.healthbar:update(dt)
  self.healthbar.x = self.x - 50
  self.healthbar.y = self.y - 50
  
  self.rot = self.angle + math.atan2(20,35)
  self.weapon.x = self.x + math.sqrt((35)^2+(20)^2) * math.cos(self.rot)
  self.weapon.y = self.y + math.sqrt((35)^2+(20)^2) * math.sin(self.rot)
  
 if(self.stats[1] > 0 and player.stats[1] > 0) then
    local dx = player.x-self.x
    local dy = player.y - self.y
  
    if(math.sqrt((dx)^2+(dy)^2) <= 450 and math.sqrt((dx)^2+(dy)^2) >= 150 and not self.attacking)then
      self.angle = math.atan2(dy,dx)
    
      self.x = self.x + math.random(50,65)  * math.cos(self.angle) * dt
      self.y = self.y + math.random(50,65)  * math.sin(self.angle) * dt
    end
  
    if(math.sqrt((player.x-self.x)^2+(player.y - self.y)^2) >= 100 and math.sqrt((player.x-self.x)^2+(player.y - self.y)^2) < 150 and not self.attacking and self.stats[5] >= self.stats[6]/2 and ( self.offsety == 0 or self.offsetx == 0)) then
      self.angle = math.atan2(dy,dx)
      self.attacking = true
    end
    
    if(math.sqrt((player.x-self.x)^2+(player.y - self.y)^2) < 100) then
      --self.angle = math.atan2(dy,dx)
    
      self.x = self.x - math.random(50,65)  * math.cos(self.angle) * dt
      self.y = self.y - math.random(50,65)  * math.sin(self.angle) * dt
      
    end
  
    if(self.stats[5] < self.stats[6]/2 and not self.attacking) then
      self.stats[5] = self.stats[5] + 7 * dt
      self.angle = math.atan2(dy,dx)
    end
  
   
  
    if(self.attacking) then
      self:attack(dt)
    elseif(not self.attacking and (self.offsety > 0 or self.offsetx > 0)) then
      self.angle = math.atan2(dy,dx)
      self.y = self.y + self.offsety * 12 * math.sin(self.angle)
      self.x = self.x + self.offsetx * 12 * math.cos(self.angle)
      self.offsety = 0
      self.offsetx = 0
      
      self.angle = math.atan2(dy,dx)
      self.rot = self.angle + math.atan2(20,35)
  
      self.weapon.x = self.x + math.sqrt((35)^2+(20)^2) * math.cos(self.rot)
      self.weapon.y = self.y + math.sqrt((35)^2+(20)^2) * math.sin(self.rot)
     
      self.weapon.x = (self.weapon.x) + (20 * math.cos(self.angle))
      self.weapon.y = (self.weapon.y) + (20 * math.sin(self.angle))
      
      hit[#hit+1] = hit.new(self.weapon.x,self.weapon.y)
      
    end
    --self:collide(dt)
   -- self:damage(dt)
 end
 
 if(self.stats[1] <= 0) then
   self.r = self.r - 50 * dt
 end
 
 if(self.r <= 0) then
    self.die = true
 end
  
end

function phantom.draw(self)
  love.graphics.setColor(255,255,255,self.r)
  love.graphics.draw(model2,self.weapon.x,self.weapon.y,self.angle,3,1,12.5,2.5)
  love.graphics.draw(model3,self.x,self.y,self.angle,1,1,25,25)
  
  --love.graphics.setColor(0,0,0)
 -- love.graphics.rectangle("line",self.hitbox.x,self.hitbox.y,50,50)
 -- love.graphics.rectangle("line",(self.weapon.x) + (20 * math.cos(self.angle)),(self.weapon.y) + (20 * math.sin(self.angle)),5,5)
  --love.graphics.setColor(255,255,55)
  
  if(self.stats[1] > 0) then
    self.healthbar:draw()
  end
  love.graphics.setColor(255,255,255,255)
end


function phantom.attack(self,dt)
  self.timer = self.timer + dt
  if(self.timer < 1) then
    local x = 10  * math.cos(self.angle) * dt
    local y = 10  * math.sin(self.angle) * dt
    self.y = self.y + x
    self.x = self.x + y
    self.offsety = self.offsety + 5 *dt
    self.offsetx = self.offsetx + 5 * dt
    self.angle = self.angle +  dt
    self.stats[5] = self.stats[5] - 25 * dt
  else
    self.attacking = false
    self.timer = 0
  end
  
end


--[[
function phantom.collide(self,dt)
  if(player.x+ 50 > self.weapon.x+10*math.cos(self.rot) and player.x < (self.weapon.x+10*math.cos(self.rot)) + 25 and player.y + 50 > self.weapon.y+10*math.sin(self.rot) and player.y < (self.weapon.x+10*math.sin(self.rot)) + 25) then
    player.shake = true
    player.stats[1] = player.stats[1] - 5 * dt
    blood[#blood + 1] = blood.new(player.x,player.y,math.random(-6.28,6.28))
  else
    player.shake = false
  end
end

function phantom.damage(self,dt)
  if(self.x+ 50 > player.weapon.x+10*math.cos(player.angle) and self.x < (player.weapon.x+10*math.cos(player.angle)) + 25 and self.y + 50 > player.weapon.y+10*math.sin(player.angle) and self.y < (player.weapon.x+10*math.sin(player.angle)) + 25) then
    self.stats[1] = self.stats[1] - (15 * 1+(player.stats[3]/100)) * dt
    blood[#blood + 1] = blood.new(self.x,self.y,math.random(-6.28,6.28))
  end
end
]]--