
player = {}
player.x = 400
player.y = 300
player.shake = false
player.running = false
player.runfactor = 0
player.moveFactor = 5
player.moving = false
player.dieSound = false
-- hp maxHp attack defense stamina, maxStamina
player.stats = {100,100,100,1000,75,75}
player.healthbar = progressbar.new(0,0,player,200,10,{0,155,0},1,2)
player.staminabar = progressbar.new(0,10,player,200,10,{155,155,0},5,6)
player.angle = 0
player.charge = 0
player.attacking = false

player.hitbox = {}
player.hitbox.x = player.x
player.hitbox.y = player.y
player.hitbox.w = 50
player.hitbox.h = 50

player.velX = 0
player.velY = 0

--

player.r = 255

player.weapon = {}
player.weapon.x = player.x
player.weapon.y = player.y
player.weapon.model =model2
player.weapon.angle = 0

player.shakeTimer = 0



function player.update(dt)
  
  player.collide(dt)
  
  player.healthbar:update(dt)
  player.staminabar:update(dt)
  
  if(player.stats[1] > 0) then
    
  
    if(love.keyboard.isDown("w")) then
      player.velY =  - (150 + player.runfactor) * dt
      player.moving = true
      player.moveFactor = 2
    end
    if(love.keyboard.isDown("a")) then
      player.velX = -(150 + player.runfactor) * dt
      player.moving = true
      player.moveFactor = 2
    end
    if(love.keyboard.isDown("s")) then
      player.velY = (150 + player.runfactor) * dt
      player.moving = true
      player.moveFactor = 2
    end
    if(love.keyboard.isDown("d")) then
      player.velX = (150 + player.runfactor) * dt
      player.moving = true
      player.moveFactor = 2
    end
  
    if(not love.keyboard.isDown("w") and not love.keyboard.isDown("a") and not love.keyboard.isDown("s") and not love.keyboard.isDown("d")) then
      player.moving = false
      player.moveFactor = 5
      player.velX = 0
      player.velY = 0
    end
    
    player.x = player.x + player.velX
    player.y = player.y + player.velY
    
    player.hitbox.x = player.x - player.hitbox.w/2
    player.hitbox.y = player.y - player.hitbox.h/2
  
    player.weapon.angle  = player.angle + math.atan2(20,35)
  
    player.weapon.x = player.x + math.sqrt((35)^2+(20)^2) * math.cos(player.weapon.angle )
    player.weapon.y = player.y + math.sqrt((35)^2+(20)^2) * math.sin(player.weapon.angle )

  
    if(player.running and player.stats[5] > 0) then
      player.runfactor = 100
      if(player.moving) then
        player.stats[5] = player.stats[5] - 5 * dt
      end
    elseif(not player.running or (player.stats[5] < 0 and player.running)) then
      player.runfactor = 0
      player.running = false
      player.stats[5] = player.stats[5] + (1 + player.moveFactor) * dt
    end
  

    if(player.attacking) then
      player.attack(dt)
    else
      player.angle = math.atan2(mouseWorldY-player.y,mouseWorldX-player.x)
      if(offsety > 0) then
        player.y = player.y + offsety * 5 * math.sin(player.angle)
        player.x = player.x + offsetx * 5 * math.cos(player.angle)
        offsety = 0
        offsetx = 0
      
      player.weapon.angle = player.angle + math.atan2(20,35)
  
      player.weapon.x = player.x + math.sqrt((35)^2+(20)^2) * math.cos(player.weapon.angle )
      player.weapon.y = player.y + math.sqrt((35)^2+(20)^2) * math.sin(player.weapon.angle )
     
      player.weapon.x = (player.weapon.x) + (20 * math.cos(player.angle))
      player.weapon.y = (player.weapon.y) + (20 * math.sin(player.angle))
      
      hit[#hit+1] = hit.new(player.weapon.x,player.weapon.y,true,player.charge)
      swoosh[#swoosh +1] = swoosh.new(player.weapon.x ,player.weapon.y + 5,player.weapon.angle)
      swooshs:stop()
      swooshs:play()
      player.charge = 0
        
      end
    end
    
    player.collide(dt)
  end
  
  if(player.stats[1] <= 0) then
    player.r = player.r - 50 * dt
    if(not player.dieSound) then
      playerdie:play()
      player.dieSound= true
    end
  end
  
  if(player.shake) then
    player.shakeTimer = player.shakeTimer+ dt
  end
  
  if(player.shakeTimer >= 0.5) then
    player.shake = false
    player.shakeTimer = 0
  end
  
end

function player.draw()
  love.graphics.setColor(255,255,255,player.r)
  love.graphics.draw(model2,player.weapon.x,player.weapon.y,player.angle,3,1,12.5,2.5)
  love.graphics.draw(model,player.x,player.y,player.angle,1,1,25,25)
  love.graphics.draw(armor1,player.x,player.y,player.angle,1,1,25,25)
 -- love.graphics.setColor(0,0,0)
  --love.graphics.rectangle("line",player.hitbox.x,player.hitbox.y,45,45)
 --love.graphics.rectangle("line",(player.weapon.x) + (20 * math.cos(player.angle)),(player.weapon.y) + (20 * math.sin(player.angle)),5,5)
 -- love.graphics.setColor(255,255,55)
 
 love.graphics.setColor(255,255,255,255)
 

 
end


function player.keypressed(key)
  if (key == "r") then
    player.running = not player.running
  end
end

function player.mousepressed(x,y,button)
  if(button == 1 and player.stats[5] > player.stats[6]/3) then
    player.attacking = true
  end
end

function player.mousereleased(x,y,button)
  if(button == 1) then
    player.attacking = false
  end
end


offsety = 0
offsetx = 0
function player.attack(dt)
  
  offsety = offsety + 10 *dt
  offsetx = offsetx + 10 *dt
  
  if(offsety < 10) then
    player.charge = player.charge + 5 * dt
    player.y = player.y + 10  * math.sin(player.angle) * dt
    player.x = player.x + 10 * math.cos(player.angle)* dt
    player.angle = player.angle +  dt
    player.stats[5] = player.stats[5] - 25 * dt
  elseif(offsety >= 20) then
    player.attacking = false  
    player.shake = false
  end
  
  if(offsety >= 15 and offsety < 20) then
    player.shake = true
  end
end


function player.collide(dt)
  for _,v in ipairs(tile) do
    if((v.type == 64 or v.type == 127)and(math.sqrt((cam.x - v.x)^2+(cam.y-v.y)^2) < 650)) then
      if(player.hitbox.x + player.hitbox.w > v.x and player.hitbox.x < v.x + 100 and player.hitbox.y + player.hitbox.h > v.y and player.hitbox.y < v.y + 100) then
        
      end
    end
  end
end